Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.h	(revision 1006)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.h	(revision 1021)
@@ -32,4 +32,7 @@
 class MergeCandidate;
 class BoundingBoxConverter;
+class VspTree;
+class OspTree;
+class VspNode;
 
 
@@ -66,5 +69,5 @@
 
 	/// view cell container types
-	enum {BSP, KD, VSP_KD, VSP_BSP};
+	enum {BSP, KD, VSP_KD, VSP_BSP, VSP_OSP};
   
 	/// render cost evaluation type
@@ -369,8 +372,4 @@
 	void CollectViewCells(const int n);
 
-	/** Returns true if this (logical) view cell is equal to a spatial node.
-	*/
-	virtual bool EqualToSpatialNode(ViewCell *viewCell) const;
-
 	/** Sets current view cells set to active, i.e., the sampling is done in this view cell set.
 	*/
@@ -472,4 +471,8 @@
 
 
+	/** Returns true if this view cell is equivalent to a node of the spatial hierarchy.
+	*/
+	virtual bool EqualToSpatialNode(ViewCell *viewCell) const;
+
 protected:
 	/** Exports bounding boxes as xml stream
@@ -528,5 +531,5 @@
 	/** Sets exporter color.
 	*/
-	virtual void ExportColor(Exporter *exporter, ViewCell *vc) const = 0;
+	virtual void ExportColor(Exporter *exporter, ViewCell *vc) const;
 
 	/** Returns volume of the view space.
@@ -619,4 +622,5 @@
 	/// if rays should be used to collect merge candidates
 	bool mUseRaysForMerge;
+
 	/// if there should be an additional merge step after the subdivision
 	bool mMergeViewCells;
@@ -718,8 +722,6 @@
 protected:
 
-
 	void CollectViewCells();
 
-	void ExportColor(Exporter *exporter, ViewCell *vc) const;
 	
 	/// the BSP tree.
@@ -799,6 +801,4 @@
 	KdNode *GetNodeForPvs(KdLeaf *leaf);
 
-	void ExportColor(Exporter *exporter, ViewCell *vc) const;
-
 
 	/// the BSP tree.
@@ -880,5 +880,5 @@
 	BspNode *GetSpatialNode(ViewCell *viewCell) const;
 
-	/** Merges the view cells.
+	/** Merges view cells according to some criteria
 	*/
 	void MergeViewCells(const VssRayContainer &rays, 
@@ -895,6 +895,4 @@
 	
 
-	void ExportColor(Exporter *exporter, ViewCell *vc) const;
-
 	/** Prepare view cells for use after loading them from disc.
 	*/
@@ -921,4 +919,14 @@
 	void EvalFromPointQueries();
 
+	/** Exports visualization of the BSP splits.
+	*/
+	void ExportSplits(const ObjectContainer &objects, 
+					  const VssRayContainer &rays);
+
+	/** Exports visualization of the BSP PVS.
+	*/
+	void ExportBspPvs(const ObjectContainer &objects,
+					  const VssRayContainer &rays);
+
 
 	/// the view space partition BSP tree.
@@ -928,8 +936,78 @@
 private:
 
-	/** Exports visualization of the BSP splits.
-	*/
-	void ExportSplits(const ObjectContainer &objects, 
-					  const VssRayContainer &rays);
+	/** test if subdivision is valid in terms of volume / area.
+	*/
+	void TestSubdivision();
+};
+
+
+/**
+	Manages different higher order operations on the view cells.
+*/
+class VspOspViewCellsManager: public ViewCellsManager
+{
+
+public:
+
+	VspOspViewCellsManager(VspTree *tree, OspTree *ospTree);
+	~VspOspViewCellsManager();
+
+	int ConstructSubdivision(const ObjectContainer &objects,
+							 const VssRayContainer &rays);
+
+	int PostProcess(const ObjectContainer &objects, 
+					const VssRayContainer &rays);
+
+	void Visualize(const ObjectContainer &objects,
+				   const VssRayContainer &sampleRays);
+
+	int GetType() const;
+	
+	ViewCell *GenerateViewCell(Mesh *mesh = NULL) const;
+
+	bool ViewCellsConstructed() const;
+
+	
+	int CastLineSegment(const Vector3 &origin,
+						const Vector3 &termination,
+						ViewCellContainer &viewcells);
+
+	float GetProbability(ViewCell *viewCell);
+	
+	ViewCell *GetViewCell(const Vector3 &point, const bool active = false) const;
+
+	bool GetViewPoint(Vector3 &viewPoint) const;
+
+	bool ViewPointValid(const Vector3 &viewPoint) const;
+
+	void CreateMesh(ViewCell *vc);
+
+	bool ExportViewCells(const string filename, const bool exportPvs, const ObjectContainer &objects);
+
+	int CastBeam(Beam &beam);
+
+	void ExportViewCellGeometry(Exporter *exporter, 
+								ViewCell *vc,
+								const Plane3 *clipPlane = NULL) const;
+
+	void Finalize(ViewCell *viewCell, const bool createMesh);
+
+
+protected:
+
+	int ComputeBoxIntersections(const AxisAlignedBox3 &box, ViewCellContainer &viewCells) const;
+	
+	void CollectViewCells();
+
+
+	/** Prepare view cells for use after loading them from disc.
+	*/
+	void PrepareLoadedViewCells();
+
+	/** Constructs merge hierarchy which corresponds to the spatial hierarchy.
+	*/
+	ViewCell *ConstructSpatialMergeTree(VspNode *root);
+
+	void UpdatePvsForEvaluation(ViewCell *root, ObjectPvs &pvs);
 
 	/** Exports visualization of the BSP PVS.
@@ -938,7 +1016,8 @@
 					  const VssRayContainer &rays);
 
-	/** test if subdivision is valid in terms of volume / area.
-	*/
-	void TestSubdivision();
+
+	/// the view space partition tree.
+	VspTree *mVspTree;
+	OspTree *mOspTree;
 };
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 1020)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 1021)
@@ -706,6 +706,6 @@
 	case SPATIAL_BOX_BASED_DISTRIBUTION:
 		return new SpatialBoxBasedDistribution(*this);
-	case OBJECTS_INTERIOR_DISTRIBUTION:
-		return new ObjectsInteriorDistribution(*this);
+	//case OBJECTS_INTERIOR_DISTRIBUTION:
+	//	return new ObjectsInteriorDistribution(*this);
 	default: // no valid strategy
 		return NULL;
Index: GTP/trunk/Lib/Vis/Preprocessing/src/SamplingStrategy.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/SamplingStrategy.h	(revision 1020)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/SamplingStrategy.h	(revision 1021)
@@ -86,5 +86,5 @@
 	for sampling the inside of a colon.
 */
-class ObjectsInteriorDistribution: public SamplingStrategy
+/*class ObjectsInteriorDistribution: public SamplingStrategy
 {
  public:
@@ -94,5 +94,5 @@
 	 virtual bool GenerateSample(SimpleRay &ray) const;
 };
-
+*/
 };
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.cpp	(revision 1020)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.cpp	(revision 1021)
@@ -50,4 +50,69 @@
 
 
+
+void VspTreeStatistics::Print(ostream &app) const
+{
+#if TODO
+	app << "===== BspTree statistics ===============\n";
+
+	app << setprecision(4);
+
+	app << "#N_CTIME  ( Construction time [s] )\n" << Time() << " \n";
+
+	app << "#N_NODES ( Number of nodes )\n" << nodes << "\n";
+
+	app << "#N_INTERIORS ( Number of interior nodes )\n" << Interior() << "\n";
+
+	app << "#N_LEAVES ( Number of leaves )\n" << Leaves() << "\n";
+
+	app << "#N_POLYSPLITS ( Number of polygon splits )\n" << polySplits << "\n";
+
+	app << "#AXIS_ALIGNED_SPLITS (number of axis aligned splits)\n" << splits[0] + splits[1] + splits[2] << endl;
+
+	app << "#N_SPLITS ( Number of splits in axes x y z)\n";
+
+	for (int i = 0; i < 3; ++ i)
+		app << splits[i] << " ";
+	app << endl;
+
+	app << "#N_PMAXDEPTHLEAVES ( Percentage of leaves at maximum depth )\n" 
+		<<	maxDepthNodes * 100 / (double)Leaves() << endl;
+
+	app << "#N_PMINPVSLEAVES  ( Percentage of leaves with mininimal PVS )\n" 
+		<< minPvsNodes * 100 / (double)Leaves() << endl;
+
+	app << "#N_PMINRAYSLEAVES  ( Percentage of leaves with minimal number of rays)\n" 
+		<< minRaysNodes * 100 / (double)Leaves() << endl;
+
+	app << "#N_MAXCOSTNODES  ( Percentage of leaves with terminated because of max cost ratio )\n"
+		<< maxCostNodes * 100 / (double)Leaves() << endl;
+
+	app << "#N_PMINPROBABILITYLEAVES  ( Percentage of leaves with mininum probability )\n"
+		<< minProbabilityNodes * 100 / (double)Leaves() << endl;
+
+	app << "#N_PMAXRAYCONTRIBLEAVES  ( Percentage of leaves with maximal ray contribution )\n" 
+		<<	maxRayContribNodes * 100 / (double)Leaves() << endl;
+
+	app << "#N_PMAXDEPTH ( Maximal reached depth )\n" << maxDepth << endl;
+
+	app << "#N_PMINDEPTH ( Minimal reached depth )\n" << minDepth << endl;
+
+	app << "#AVGDEPTH ( average depth )\n" << AvgDepth() << endl;
+
+	app << "#N_INPUTPOLYGONS (number of input polygons )\n" << polys << endl;
+
+	app << "#N_INVALIDLEAVES (number of invalid leaves )\n" << invalidLeaves << endl;
+
+	app << "#N_RAYS (number of rays / leaf)\n" << AvgRays() << endl;
+	//app << "#N_PVS: " << pvs << endl;
+
+	app << "#N_ROUTPUT_INPUT_POLYGONS ( ratio polygons after subdivision / input polygons )\n" <<
+		 (polys + polySplits) / (double)polys << endl;
+	
+	app << "===== END OF BspTree statistics ==========\n";
+#endif
+}
+
+
 /******************************************************************/
 /*                  class VspNode implementation                  */
@@ -218,9 +283,9 @@
 }
 
+
 int VspLeaf::Type() const
 {
 	return Leaf;
 }
-
 
 
@@ -1383,4 +1448,10 @@
 
 
+void VspTree::SetViewCellsManager(ViewCellsManager *vcm)
+{
+	mViewCellsManager = vcm;
+}
+
+
 void VspTree::ValidateTree()
 {
@@ -2160,6 +2231,81 @@
 
 
+
+int VspTree::ComputeBoxIntersections(const AxisAlignedBox3 &box,
+									 ViewCellContainer &viewCells) const
+{
+#if TODO
+	stack<bspNodePair> nodeStack;
+	BspNodeGeometry *rgeom = new BspNodeGeometry();
+
+	ConstructGeometry(mRoot, *rgeom);
+
+	nodeStack.push(bspNodePair(mRoot, rgeom));
+  
+	ViewCell::NewMail();
+
+	while (!nodeStack.empty()) 
+	{
+		BspNode *node = nodeStack.top().first;
+		BspNodeGeometry *geom = nodeStack.top().second;
+		nodeStack.pop();
+
+		const int side = geom->ComputeIntersection(box);
+		
+		switch (side)
+		{
+		case -1:
+			// node geometry is contained in box
+			CollectViewCells(node, true, viewCells, true);
+			break;
+
+		case 0:
+			if (node->IsLeaf())
+			{
+				BspLeaf *leaf = dynamic_cast<BspLeaf *>(node);
+			
+				if (!leaf->GetViewCell()->Mailed() && leaf->TreeValid())
+				{
+					leaf->GetViewCell()->Mail();
+					viewCells.push_back(leaf->GetViewCell());
+				}
+			}
+			else 
+			{
+				BspInterior *interior = dynamic_cast<BspInterior *>(node);
+			
+				BspNode *first = interior->GetFront();
+				BspNode *second = interior->GetBack();
+            
+				BspNodeGeometry *firstGeom = new BspNodeGeometry();
+				BspNodeGeometry *secondGeom = new BspNodeGeometry();
+
+				geom->SplitGeometry(*firstGeom,
+									*secondGeom,
+									interior->GetPlane(),
+									mBox,
+									//0.0000001f);
+									mEpsilon);
+
+				nodeStack.push(bspNodePair(first, firstGeom));
+				nodeStack.push(bspNodePair(second, secondGeom));
+			}
+			
+			break;
+		default:
+			// default: cull
+			break;
+		}
+		DEL_PTR(geom);
+	}
+
+#endif
+	return (int)viewCells.size();
+}
+
+
+
 /*****************************************************************/
-/*                class OpsTree implementation                   */
+/*                class OspTree implementation                   */
 /*****************************************************************/
 
@@ -2333,7 +2479,87 @@
 
 
-/*****************************************************************/
-/*              class HierarchyManager implementation            */
-/*****************************************************************/
+bool OspTree::LocalTerminationCriteriaMet(const OspTraversalData &data) const
+{
+	// matt: TODO
+	return true;
+    /*		(((int)data.mRays->size() <= mTermMinRays) ||
+		 (data.mPvs <= mTermMinPvs)   ||
+		 (data.mProbability <= mTermMinProbability) ||
+		 (data.GetAvgRayContribution() > mTermMaxRayContribution) ||
+		 (data.mDepth >= mTermMaxDepth));*/
+}
+
+
+bool OspTree::GlobalTerminationCriteriaMet(const OspTraversalData &data) const
+{
+	// matt: TODO
+	return true;
+		/*(mOutOfMemory || 
+		(mVspStats.Leaves() >= mMaxViewCells) || 
+		(mGlobalCostMisses >= mTermGlobalCostMissTolerance));*/
+}
+
+
+void OspTree::EvaluateLeafStats(const OspTraversalData &data)
+{
+#if TODO
+	// the node became a leaf -> evaluate stats for leafs
+	VspLeaf *leaf = dynamic_cast<VspLeaf *>(data.mNode);
+
+	if (data.mPvs > mVspStats.maxPvs)
+	{
+		mVspStats.maxPvs = data.mPvs;
+	}
+
+	mVspStats.pvs += data.mPvs;
+
+	if (data.mDepth < mVspStats.minDepth)
+	{
+		mVspStats.minDepth = data.mDepth;
+	}
+	
+	if (data.mDepth >= mTermMaxDepth)
+	{
+        ++ mVspStats.maxDepthNodes;
+		//Debug << "new max depth: " << mVspStats.maxDepthNodes << endl;
+	}
+
+	// accumulate rays to compute rays /  leaf
+	mVspStats.accumRays += (int)data.mRays->size();
+
+	if (data.mPvs < mTermMinPvs)
+		++ mVspStats.minPvsNodes;
+
+	if ((int)data.mRays->size() < mTermMinRays)
+		++ mVspStats.minRaysNodes;
+
+	if (data.GetAvgRayContribution() > mTermMaxRayContribution)
+		++ mVspStats.maxRayContribNodes;
+
+	if (data.mProbability <= mTermMinProbability)
+		++ mVspStats.minProbabilityNodes;
+	
+	// accumulate depth to compute average depth
+	mVspStats.accumDepth += data.mDepth;
+
+	++ mCreatedViewCells;
+
+#ifdef _DEBUG
+	Debug << "BSP stats: "
+		  << "Depth: " << data.mDepth << " (max: " << mTermMaxDepth << "), "
+		  << "PVS: " << data.mPvs << " (min: " << mTermMinPvs << "), "
+	  //		  << "Area: " << data.mProbability << " (min: " << mTermMinProbability << "), "
+		  << "#rays: " << (int)data.mRays->size() << " (max: " << mTermMinRays << "), "
+		  << "#pvs: " << leaf->GetViewCell()->GetPvs().GetSize() << "=, "
+		  << "#avg ray contrib (pvs): " << (float)data.mPvs / (float)data.mRays->size() << endl;
+#endif
+
+#endif
+}
+
+
+/*********************************************************************/
+/*                class HierarchyManager implementation              */
+/*********************************************************************/
 
 HierarchyManager::HierarchyManager()
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1020)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1021)
@@ -272,4 +272,10 @@
 	}
 	Debug << "empty view cells found: " << (int)mEmptyViewCells.size() << endl;
+}
+
+
+bool ViewCellsManager::EqualToSpatialNode(ViewCell *viewCell) const 
+{ 
+	return false;
 }
 
@@ -1175,4 +1181,5 @@
 }
 
+
 bool ViewCellsManager::CheckValidity(ViewCell *vc,
 									 int minPvsSize,
@@ -1190,9 +1197,4 @@
 
 
-bool ViewCellsManager::EqualToSpatialNode(ViewCell *viewCell) const 
-{ 
-	return false;
-}
-
 int ViewCellsManager::ComputeBoxIntersections(const AxisAlignedBox3 &box, 
 											  ViewCellContainer &viewCells) const
@@ -1200,4 +1202,5 @@
 	return 0;
 };
+
 
 AxisAlignedBox3 ViewCellsManager::GetFilterBBox(const Vector3 &viewPoint, 
